
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rif_f.h"

extern void	Error(char *msg);

#define LEN	2048
#define ULL	unsigned long long

int	main(int argc,char **argv)
{
	char	path[LEN],*id,str[8][LEN],*u_c,
		*u="using integer PV as is floating-point PV",
		*c="converting PV by TIFF image description tag";
	int	bps,x,y,n,Nx,Ny,x1,y1,x2,y2;
	FOM	**fom;
	double	min,max,base,step,val,S1=0.0,S2=0.0;
	ULL	S0=0;

	if (argc!=1 && argc!=5) Error("usage : n+m+sd_float {x1 y1 x2 y2}");

	while (scanf("%s",path)==1) {
	    if ((bps=ReadImageFile_Float(path,&x,&y,&fom,&id))!=0) {
		if (id!=NULL) {
		    if ((n=sscanf(id,"%s %s %s %s %s %s %s %s",
				     str[0],str[1],str[2],str[3],
				     str[4],str[5],str[6],str[7]))==2 || n==6)
			if (sscanf(str[n-2],"%lf",&min)!=1 ||
			    sscanf(str[n-1],"%lf",&max)!=1 || min>=max) {
			    u_c=u; base=0.0; step=1.0;
			}
			else {
			    u_c=c; base=min; step=(max-min)/(double)((1ULL<<bps)-1);
			}
		    else
			if ((n!=3 && n!=4 && n!=8) ||
			    sscanf(str[n-2],"%lf",&base)!=1 ||
			    sscanf(str[n-1],"%lf",&step)!=1 || step<=0.0) {
			    u_c=u; base=0.0; step=1.0;
			}
			else
			    u_c=c;

		    free(id);
		}
		else {
		    u_c=u; base=0.0; step=1.0;
		}
#ifdef	U_C
		(void)fprintf(stderr,"%s : %s (warning).\n",path,u_c);
#endif
	    }
	    else {
		base=0.0; step=1.0; if (id!=NULL) free(id);
	    }
	    if (S0==0) {
		Nx=x; Ny=y;

		if (argc==1) {
		    x1=y1=0; x2=Nx-1; y2=Ny-1;
		}
		else
		    if ((x1=atoi(argv[1]))<0 ||
			(y1=atoi(argv[2]))<0 ||
			(x2=atoi(argv[3]))>=Nx || x1>x2 ||
			(y2=atoi(argv[4]))>=Ny || y1>y2) Error("bad image area.");
	    }
	    else
		if (x!=Nx || y!=Ny) {
		    (void)fputs(path,stderr); Error(" : image size not match.");
		}

	    for (y=y1; y<=y2; y++)
	    for (x=x1; x<=x2; x++) {
		++S0; S1+=(val=base+step*fom[y][x]); S2+=(val*val);
	    }
	    for (y=0; y<Ny; y++) free(fom[y]); free(fom);
	}
	if (S0!=0)
	    (void)printf("%llu\t%lf\t%lf\n",
			 S0,
			 S1/(double)S0,
			 sqrt((S2-S1*S1/(double)S0)/(double)S0));

	return 0;
}
