#!/bin/csh
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
if ($#argv != 2) then
  STDERR usage : rec2mm.csh rec.tif mm.tif ; exit 1
endif
#
set rec=$argv[1]
if (!(-e $rec)) then
  STDERR $rec : file not found. ; exit 1
endif
#
set mm=(`( pig $rec ; \
           pid $rec ) | \
         awk 'NR==1 { if (NF!=4 || $4!=16) exit } \
              NR==2 { if (NF==8) printf "%s %f\n",$4,$4+65536/$3 }'`)
if ($#mm != 2) then
  STDERR $rec : bad file format. ; exit 1
endif
#
echo -n $mm | tr ' ' \\t | sid $rec - $argv[2]
