
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include "sgif.h"

#define UCHAR	unsigned char

#if	UINT_MAX==0xffffffff
#define UINT	unsigned int
#elif	ULONG_MAX==0xffffffff
#define UINT	unsigned long
#else
#error no suitable type for 32-bit integer.
#endif

UCHAR	StoreGIF_Gray[256]={
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
	 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
	 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
	 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
	 96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
	112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
	128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
	144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
	160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
	176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
	192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
	208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
	224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
	240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255};

#define FPUTC(byte,file)	(void)fputc((int)(byte),file)
#define FPUTW(word,file)	FPUTC(word&255,file); FPUTC(word>>8,file)

void	InitStoreGIF(FILE *file,int Nx,int Ny,UCHAR *cmR,UCHAR *cmG,UCHAR *cmB)
{
	int	i;

	(void)fwrite("GIF87a",6,1,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	if (cmR==NULL || cmG==NULL || cmB==NULL) {
	    FPUTC(0x70|(8-1),file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	}
	else {
	    FPUTC(0xf0|(8-1),file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	    for (i=0; i<256; i++) {
		FPUTC(cmR[i],file);
		FPUTC(cmG[i],file);
		FPUTC(cmB[i],file);
	    }
	}
}

static UINT	buf;
static int	num,len;
static UCHAR	block[256];

static inline void	Put(int code,FILE *file)
{
	buf|=((UINT)code<<num);
	for (num+=len; num>=8; num-=8) {
	    block[++(*block)]=(UCHAR)(buf&255); buf>>=8;
	    if (*block==255) {
		(void)fwrite(block,256,1,file); *block=0;
	    }
	}
}

static int	ent,roof,head;
static UINT	str[9001];

static inline void	InitEncode(FILE *file)
{
	int	i;

	FPUTC(8,file);

	buf=0; num=0; len=9; *block=0; Put(256,file);
	ent=258; roof=512; head=4096;
	for (i=0; i<9001; i++) str[i]=0;
}

static inline void	Encode(int tail,FILE *file)
{
	UINT	h_t;
	int	i,j;

	if (head!=4096) {
	    h_t=(((UINT)head<<8)|tail)<<12;
	    if (str[i=head^(tail<<5)]!=0) {
		if ((str[i]&0xfffff000)==h_t) {
		    head=(int)(str[i]&0xfff); return;
		}
		j=(i==0)?9000:i;
		while (str[i=(i+j)%9001]!=0)
		    if ((str[i]&0xfffff000)==h_t) {
			head=(int)(str[i]&0xfff); return;
		    }
	    }
	    Put(head,file);
	    if (ent!=4096) {
		str[i]=h_t|ent;
		if (ent==roof) {
		    ++len; roof<<=1;
		}
		++ent;
	    }
	    else {
		Put(256,file);
		len=9; ent=258; roof=512;
		for (i=0; i<9001; i++) str[i]=0;
	    }
	}
	head=tail;
}

static inline void	TermEncode(FILE *file)
{
	if (head!=4096) {
	    Put(head,file); if (ent==roof) ++len;
	}
	Put(257,file);
	if (num!=0) block[++(*block)]=(UCHAR)buf;
	if (*block!=0) (void)fwrite(block,(size_t)*block+1,1,file);

	FPUTC(0,file);
}

void	StoreGIF(FILE *file,int xO,int yO,int Nx,int Ny,
		 UCHAR *cmR,UCHAR *cmG,UCHAR *cmB,UCHAR **pv)
{
	int	i,x,y;

	FPUTC(',',file);
	FPUTW(xO,file);
	FPUTW(yO,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	if (cmR==NULL || cmG==NULL || cmB==NULL)
	    FPUTC(8-1,file);
	else {
	    FPUTC(0x80|(8-1),file);
	    for (i=0; i<256; i++) {
		FPUTC(cmR[i],file);
		FPUTC(cmG[i],file);
		FPUTC(cmB[i],file);
	    }
	}
	InitEncode(file);
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) Encode((int)pv[y][x],file);
	TermEncode(file);
}

#ifndef	STATIC_LUT
typedef struct {
		UINT	c[256][256][256];
		UCHAR	r[256*256*256],g[256*256*256],b[256*256*256];
		struct {
			UINT	c,l,u;
			UCHAR	w,r,g,b;
		} bin[256];
	} LUT;

static LUT	*lut=NULL;

#define C	lut->c
#define R	lut->r
#define G	lut->g
#define B	lut->b
#define Bin	lut->bin
#else
static UINT	C[256][256][256];
static UCHAR	R[256*256*256],G[256*256*256],B[256*256*256];
static struct {
		UINT	c,l,u;
		UCHAR	w,r,g,b;
	} Bin[256];
#endif

static inline UINT	Bisect(UINT l,UINT u,UCHAR *RGB,UCHAR rgb)
{
	UINT	i,j;
	UCHAR	k;

	for (i=l; i<u; i++) if (RGB[i]>=rgb) break;

	for (j=i+1; j<u; j++)
	    if (RGB[j]<rgb) {
		k=R[i]; R[i]=R[j]; R[j]=k;
		k=G[i]; G[i]=G[j]; G[j]=k;
		k=B[i]; B[i]=B[j]; B[j]=k; ++i;
	    }

	return i;
}

static inline void	Register(UINT l,UINT u,UCHAR w,UCHAR r,UCHAR g,UCHAR b)
{
	UINT	i,
		c=0;

	for (i=l; i<u; i++) c+=C[R[i]][G[i]][B[i]];

	for (i=0; i<256; i++) if (Bin[i].c==0) break;

	Bin[i].c=c;
	if ((Bin[i].l=l)==(Bin[i].u=u)-1)
	    Bin[i].w=0;
	else {
	    Bin[i].w=w; Bin[i].r=r; Bin[i].g=g; Bin[i].b=b;
	}
}

void	StoreGIF_RGB(FILE *file,int xO,int yO,int Nx,int Ny,
		     UCHAR **pvR,UCHAR **pvG,UCHAR **pvB)
{
	UINT	r,g,b,i,l,u,c,j,
		o=0;
	int	y,x,
		n=0;
	UCHAR	r0,g0,b0,w,r1,g1,b1;
	double	r2,g2,b2,d;

#ifndef	STATIC_LUT
	if (lut==NULL && ((lut=(LUT *)malloc(sizeof(LUT)))==NULL)) {
	    fputs("look-up-table memory allocation error.\n",stderr); exit(1);
	}
#endif
	FPUTC(',',file);
	FPUTW(xO,file);
	FPUTW(yO,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	FPUTC(0x80|(8-1),file);

	for (r=0; r<256; r++)
	for (g=0; g<256; g++)
	for (b=0; b<256; b++) C[r][g][b]=0;

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if (++C[r0=pvR[y][x]]
		   [g0=pvG[y][x]]
		   [b0=pvB[y][x]]==1) {
		R[o]=r0; G[o]=g0; B[o]=b0; ++o;
	    }

	if (o<=256)
	    for (i=0; i<o; i++) {
		FPUTC(r0=R[i],file);
		FPUTC(g0=G[i],file);
		FPUTC(b0=B[i],file); C[r0][g0][b0]=n++;
	    }
	else {
	    for (i=0; i<256; i++) Bin[i].c=0;

	    l=0; u=o; r0=g0=b0=0; w=r1=g1=b1=128;
	    for (;;) {
		r=Bisect(l,u,R,r1);
		if (l<r) {
		    g=Bisect(l,r,G,g1);
		    if (l<g) {
			b=Bisect(l,g,B,b1);
			if (l<b) {
			    Register(l,b,w,r0,g0,b0); ++n;
			}
			if (b<g) {
			    Register(b,g,w,r0,g0,b1); ++n;
			}
		    }
		    if (g<r) {
			b=Bisect(g,r,B,b1);
			if (g<b) {
			    Register(g,b,w,r0,g1,b0); ++n;
			}
			if (b<r) {
			    Register(b,r,w,r0,g1,b1); ++n;
			}
		    }
		}
		if (r<u) {
		    g=Bisect(r,u,G,g1);
		    if (r<g) {
			b=Bisect(r,g,B,b1);
			if (r<b) {
			    Register(r,b,w,r1,g0,b0); ++n;
			}
			if (b<g) {
			    Register(b,g,w,r1,g0,b1); ++n;
			}
		    }
		    if (g<u) {
			b=Bisect(g,u,B,b1);
			if (g<b) {
			    Register(g,b,w,r1,g1,b0); ++n;
			}
			if (b<u) {
			    Register(b,u,w,r1,g1,b1); ++n;
			}
		    }
		}
		if (n>256+1-8) break;

		c=0;
		for (i=0; i<256; i++)
		    if (Bin[i].c>c && Bin[i].w>1) c=Bin[j=i].c;

		if (c==0) break;

		Bin[j].c=0; l=Bin[j].l;
			    u=Bin[j].u;
			    w=Bin[j].w>>1; r1=(r0=Bin[j].r)+w;
					   g1=(g0=Bin[j].g)+w;
					   b1=(b0=Bin[j].b)+w; --n;
	    }
	    n=0;
	    for (i=0; i<256; i++)
		if ((c=Bin[i].c)!=0) {
		    r2=g2=b2=0.0;
		    for (j=Bin[i].l; j<Bin[i].u; j++) {
			d=(double)C[r0=R[j]][g0=G[j]][b0=B[j]]/(double)c;
			r2+=(d*(double)r0);
			g2+=(d*(double)g0);
			b2+=(d*(double)b0); C[r0][g0][b0]=n;
		    }
		    FPUTC(r2+0.5,file);
		    FPUTC(g2+0.5,file);
		    FPUTC(b2+0.5,file); ++n;
		}
	}
	while (++n<=256) {
	    FPUTC(0,file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	}
	InitEncode(file);
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) Encode((int)C[pvR[y][x]]
					  [pvG[y][x]]
					  [pvB[y][x]],file);
	TermEncode(file);
}

void	TermStoreGIF(FILE *file)
{
#ifndef	STATIC_LUT
	if (lut!=NULL) {
	    free(lut); lut=NULL;
	}
#endif
	FPUTC(';',file);
}
